#include <timeconvert.h>
#include <tea5764.h>


//data 
//local dateTime
signed   char localHours;	  
signed   char localMinutes;
unsigned char localYear;
unsigned char localMonth;
unsigned char localDay;
unsigned char localWDay;

//table with days per month 
code unsigned char Mtbl[4][12]={{31,29,31,30,31,30,31,31,30,31,30,31},{31,28,31,30,31,30,31,31,30,31,30,31},{31,28,31,30,31,30,31,31,30,31,30,31},{31,28,31,30,31,30,31,31,30,31,30,31}};

//incremet Minut by one
bit IncMinute(void)
{
	//inc minutes
	//uart_transmit('I');
	localMinutes++;
	if(localMinutes==60)
		{ //inc hours
		localHours++;
		if(localHours==24)
			return 0;	
		}
return 1;
}

//decode the date (MJD) and time recived from RDS
void DecodeRDSDateAndTime()
{
signed char Dayoffset=DecodeRDSTime();	//local time offset
unsigned long  modifiedJulianDay;
unsigned int Days2000;				   //days since 1.1.2000
unsigned char yIndex;    			   //schaltjahr...
unsigned int Days;    				   //day of the year


	//get MJD
	//bits 0-14 are in block3 as bits 1-15
	//bits 15-16 are in block2 as bits 0-1
	
	modifiedJulianDay = (unsigned int)((unsigned int)(rds_data_ct[ 0 ] & 0x1) << 15) | (unsigned int)(rds_data_ct[ 1 ] << 7) | (unsigned int)(rds_data_ct[ 2 ] >> 1);

	//modifiedJulianDay =55561; //31.12.2010
	//days since 1.1.2000
	Days2000=modifiedJulianDay-51544L; 
	localWDay=6;			//1.1.2000 was a Sa.
	//add offset
	Days2000+=0;
	//get the number of 4 Year cycles
	for(localYear=0;Days2000>=1461;)  //1461=3x365+366
		{
		Days2000-=1461;
		localYear+=4;
		localWDay+=5;			  //day of week will move by 5 with in one cycle
		}
	//get the remaining Years
	for( yIndex=0;Days2000>365;)
		{
		Days2000-=365;
		localYear++;		
		yIndex++;
		localWDay+=1;			//the day of week will nove one day per year
		}

		if(yIndex==0)  			
			localWDay+=1;		//DoW moves one extra in schaltjahr
		while(localWDay>7)		//prevent overflow of DoW
			localWDay-=7;

	//get the Month
		localMonth=0;
		Days=Mtbl[yIndex][localMonth]; //gut the number of day for the current month
		while(Days2000>=Days)		   //more or equal than one month left?
			{
			Days2000-=Days;
			localMonth++;	
			Days=Mtbl[yIndex][localMonth];
			localWDay+=Days;
			while(localWDay>7)	//prevent overflow of DoW
				localWDay-=7;
			}
		localMonth++;		//adjust base: tech bast is zerro first month is one
	//get the Day of Month
		localDay=Days2000;
		localWDay+=localDay;
		while(localWDay>7)	   //prevent overflow of DoW
			localWDay-=7;
}


//get curren time from RDS data
signed char DecodeRDSTime(void)
{
unsigned int  localTimeOffset = 0;
unsigned char utcMinutes = 0;
unsigned char utcHours = 0;

//get Minues
		  utcMinutes= ((rds_data_ct[ 3 ] &0xF) << 2 ) | (rds_data_ct[ 4 ] >> 6);
//get Hour          
          //bits 0-3 are in block4 as bits 12-15
          //bit 4 is in block3 as bit 1
          utcHours = ((unsigned char)((rds_data_ct[ 2 ] & 0x1) << 4) | (unsigned char)(rds_data_ct[ 3 ] >> 4) );
//get local time offset
				          
          //local time offset are bits 0-4 in block 4
		  //offset is coded as multiply off 1/2 hour
          localTimeOffset = rds_data_ct[ 4 ] & 0x1F;
						 

		  localMinutes = utcMinutes;

	          //offset sign is in bit 5 of block4, 0=+ 1=-
          if ((rds_data_ct[ 4 ] & 0x20) ) 
		  	{
            localHours = utcHours - (localTimeOffset>>1);
			if((localTimeOffset&0x1)==0x1)
            	localMinutes -= 30;
			} 
			else 
			{
            localHours = utcHours + (localTimeOffset>>1);
			if((localTimeOffset&0x1)==0x1)
            	localMinutes += 30;
          	}
//handle over and under flow
          if (localMinutes < 0) 
		  {
            localMinutes += 60;
            localHours--;
          }
            
          if (localMinutes > 59) 
		  {
            localMinutes -= 60;
            localHours++;
          }
          
          if (localHours < 0)
		  	{
            localHours += 24;
			return -1;
			}
  
          if (localHours > 23)
		  	{
            localHours -= 24;
			return 1;
			}
return 0;
}
