#include <util.h>
#include <tea5764.h>
#include <uart.h>

//calculate the parity Bit for the given char
bit CalcParity(unsigned char val, bit parin)
{	  
unsigned char n;
for(n=0;n<8;n++)
	parin^=(((val&(0x1<<n)))!=0);
return parin;	
}

//convert an int to packed BCD
unsigned char ByteToBCD(unsigned char val)
{
return (val/10)<<4|(val%10);
}

//get Low nibble
char htoa_lo(unsigned char byte)   // converts low nibble of unsigned byte (0-F hex) to ascii
{
    byte = byte & 0x0F; // keep lower nibble only   
    if (byte <= 0x09)
        return(byte + 0x30);
    else
        return (byte + 0x37);
}

//get High nibble
char htoa_hi(unsigned char byte)   // converts hi nibble of unsigned byte (0-F hex) to ascii
{
    byte = byte & 0xF0;            // keep upper nibble only
    byte = byte >> 4;
    if (byte <= 0x09)
        return(byte + 0x30);
    else
        return (byte + 0x37);
}



#ifdef DEBUG

void DumpFM(void)
{
unsigned char i;
	for (i=0;i<TEA5764_FM_RCOUNT;i++)
		{
		SendAsHexWSpace(tea5764_fm_buf[i]);
		}
	SendCRLF();
} 

 
void DumpRDSct(void)
{
unsigned char i;
	for (i=0;i<5;i++)
		{
		SendAsHexWSpace(rds_data_ct[i]);
		}
	SendCRLF();
} 


char putchar (char c)
{
uart_transmit(c);
return c;
} 


#endif  