#include <timeconvert.h>
#include <util.h>
#include <timers.h>
#include <dcf.h>


unsigned char dcfData[5];

//gennerate the DCF77 Bite 20 to 58 based on local time and date
void GenDCFData(void)
{
// dcfData[0] Bits 20-27
// dcfData[1] Bits 28-35
// dcfData[2] Bits 36-43
// dcfData[3] Bits 44-51
// dcfData[4] Bits 52-59

unsigned char tmp;
unsigned char tmp2;
tmp=ByteToBCD(localMinutes);	//get minutes as BCD
dcfData[0]=0x1|tmp<<1; //Bit 20 start ,Bit 21-27 Minutes

dcfData[1]=CalcParity(tmp,0);	 
tmp=ByteToBCD(localHours)&0x3F;	 //Bit 28 Parity Minutes, Bit Bit 29-34 Hours,Bit 35 Par. Houres
tmp2=CalcParity(tmp,0);
dcfData[1]|=(tmp<<1)|(tmp2<<7);

tmp=ByteToBCD(localDay)&0x3F;	 //Bit 36-41 Day of Month  
tmp2=ByteToBCD(localWDay)&0x7;	 //Bit 42-44 Day of week
dcfData[2]=tmp|(tmp2<<6);

tmp=ByteToBCD(localMonth)&0x1F;	 //Bit 45-49 Month
dcfData[3]=(tmp2>>2)|(tmp<<1);
tmp2=ByteToBCD(localYear);	 //Bit 50-57 Year
dcfData[3]|=(tmp2<<6);
dcfData[4]=tmp2>>2;
//parity bit 36 to 58;
tmp=CalcParity(dcfData[2],CalcParity(dcfData[3],CalcParity(dcfData[4],0)));
dcfData[4]|=tmp<<6;	//bit 58 parity datum
}

//returns the bit to send in the current second
bit GetDCFBit(void)
{
if(second<=19)
	return 0;		//second 1 to 19 are always zerro
else
	{
	unsigned char i=(second-20)/8; //get tabel index
	unsigned char p=(second-20)%8; //get bit number of byte
	return (dcfData[i]&(0x1<<p));	//check if bit p of byte i is on
	}	
}
