
/***********************************************************************
MODULE:    Flash
VERSION:   1.00
CONTAINS:  Routines for programming the Flash using IAP-Lite on the
           P89LPC921
COPYRIGHT: Embedded Systems Academy, Inc. - www.esacademy.com
LICENSE:   May be freely used in commercial and non-commercial code
           without royalties provided this copyright notice remains
           in this file and unaltered
WARNING:   IF THIS FILE IS REGENERATED BY CODE ARCHITECT ANY CHANGES
           MADE WILL BE LOST. WHERE POSSIBLE USE ONLY CODE ARCHITECT
           TO CHANGE THE CONTENTS OF THIS FILE
GENERATED: On "Apr 03 2010" at "00:52:07" by Code Architect 2.13
***********************************************************************/

// SFR description needs to be included
#include <reg921.h>
#include "flash.h"
//#include <uart.h>

// flash commands
#define LOADPAGE  0x00
#define ERASEPRGM 0x68


#define LOWBYTE(address) ((unsigned char)(address))
#define HIGHBYTE(address) ((unsigned char)(((unsigned int)(address))>> 8))

/***********************************************************************
DESC:    Programs bytes in the Flash memory.
         Always takes 4ms to execute
RETURNS: 0 for error, 1 for success
CAUTION: If programming crosses a page boundary then bytes at the start
         of the page will be programmed rather than bytes in the
         following page
************************************************************************/
unsigned char flash_program
  (
  unsigned int addr,            // starting address to program
  unsigned char idata *buffer,  // pointer to buffer containing data
  unsigned char length          // number of bytes to program
  )
{
  unsigned char b;
  // start loading of page
  FMCON = LOADPAGE;
  // set start address
  FMADRH = (addr >> 8) & 0xFF;
  FMADRL = addr & 0xFF;

  // copy data into page buffer
  for (b = 0; b < length; b++)
    FMDATA = buffer[b];
  EA=0; //disable interrupst 
  // erase flash and program
  FMCON = ERASEPRGM;
  EA=1; //enable interrupst
  // check for any errors
  return (FMCON & 0x0F);
}
