/***********************************************************************
MODULE:    I2C Callback
VERSION:   1.03
CONTAINS:  Routines for controlling the I2C Peripheral on the Philips
           P89LPC935
COPYRIGHT: Embedded Systems Academy, Inc. - www.esacademy.com
LICENSE:   May be freely used in commercial and non-commercial code
           without royalties provided this copyright notice remains
           in this file and unaltered
WARNING:   IF THIS FILE IS REGENERATED BY CODE ARCHITECT ANY CHANGES
           MADE WILL BE LOST. WHERE POSSIBLE USE ONLY CODE ARCHITECT
           TO CHANGE THE CONTENTS OF THIS FILE
GENERATED: On "Jun 04 2005" at "00:29:02" by Code Architect 2.10
***********************************************************************/
//#include <string.h>


#include <reg935.h>


#include <i2c.h>
#include "i2c_callback.h"

// MASTER CALLBACK FUNCTIONS

/***********************************************************************
DESC:    gets the next byte to be transmitted when operating as
         a master
RETURNS: byte to transmit
************************************************************************/
unsigned char i2c_master_getbyte( unsigned int bytenum, char *buf )
{
  	return buf[ bytenum ];
} // i2c_master_getbyte

/***********************************************************************
DESC:    processes the bytes received when operating as a master
RETURNS: Nothing
************************************************************************/
void i2c_master_receivedbyte( unsigned int bytenum, unsigned char value, char *buf )
{
	buf[ bytenum ] = value;
} // i2c_master_receivedbyte

/***********************************************************************
DESC:    determines if a byte will be the last one to be
         transmitted when operating as a master
         called before i2c_master_getbyte for each byte
RETURNS: return 1 if the byte will be the last one to transmit
         return 0 if the byte will not be the last one to transmit
************************************************************************/
unsigned char i2c_master_islasttxbyte( unsigned int bytenum, unsigned int len )
{
	if( ( len - 1 ) <= bytenum )
  		return 1;
	else
		return 0;
} // i2c_master_islasttxbyte

/***********************************************************************
DESC:    determines if a byte will be the last one to be
         received when operating as a master
         called before i2c_master_receivedbyte for each byte
RETURNS: return 1 if the byte will be the last one to receive
         return 0 if the byte will not be the last one to receive
************************************************************************/
unsigned char i2c_master_islastrxbyte( unsigned int bytenum, int numb )
{
	if( bytenum >= ( numb - 1 ) )
		return 1;
	else
  		return 0;
} // i2c_master_islastrxbyte

/***********************************************************************
DESC:    called when an I2C transfer is finished
         mi2cstatus may be read to determine if the transfer was
         successful (I2C_OK) or failed (I2C_ERROR)
RETURNS: Nothing
************************************************************************/
/*void i2c_transfer_finished( void )
{
  // insert code here

} // i2c_transfer_finished	 
*/