#include <reg921.h>
#include "uart.h"
#include "i2c.h"
#include "delay.h"
#include <timers.h>

void no_touch921(void);

void initHW(void)
{
/*DESC:    Initializes the oscillator to generate a CPU clock at
         1.8432 MHz    Uses on-chip oscillator*/
  // clock divider
  DIVM = 0x02;
  // no clock out on CLKOUT pin
  TRIM &= ~0x40;

//Backdoor set P1.1 to weak pulled High
P1M1 &= ~0x02;
P1M2 &= ~0x02;
delay_ms(30); //  wait a while
if(!RxD)//P1.1 is low
	{
	delay_ms(30); //wait a while
	if(!RxD)//P1.1 is still low
	 	{
		EA = 0;
        no_touch921();   //activate the ISP entry routine (Bootloader)
		}
	}	

Init_Timer();	  //initialize the timer

uart_init();	  //initialize to UART

i2c_init(0,0);	
  
}